#ifndef FILEWATCHER__H
#define FILEWATCHER__H
#include <boost/filesystem.hpp>
#include <string>

class FileWatcher{
    public:
        FileWatcher(){}

        FileWatcher(const std::string &p) {setPath(p);}

        void setPath(const std::string& p){_path=p; update();}

        bool isModified(){return(_last_time < get_time());}

        std::time_t get_time(){return boost::filesystem::last_write_time(_path);}

        void update(){ _last_time=get_time(); }
    protected:
       boost::filesystem::path _path;
       std::time_t _last_time;
};

#endif
