////////////////////////////////////////////////////////////////////////
// Class:       EvTimeAna
// Module Type: analyzer
// File:        EvTimeAna_module.cc
//
// Generated at Thu Feb 23 14:44:41 2017 by Andrey Sheshukov using artmod
// from cetpkgsupport v1_10_02.
////////////////////////////////////////////////////////////////////////

#include "art/Framework/Core/EDAnalyzer.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art/Utilities/InputTag.h"
#include "fhiclcpp/ParameterSet.h"
#include "messagefacility/MessageLogger/MessageLogger.h"
#include "DDTBaseDataProducts/EventHeader.h"	
#include "DDTBaseDataProducts/HitList.h"
#include <limits>
#include <iomanip>

namespace novaddt {
  class EvTimeAna;
}

class novaddt::EvTimeAna : public art::EDAnalyzer {
public:
  explicit EvTimeAna(fhicl::ParameterSet const & p);
  // The destructor generated by the compiler is fine for classes
  // without bare pointers or other resource use.

  // Plugins should not be copied or assigned.
  EvTimeAna(EvTimeAna const &) = delete;
  EvTimeAna(EvTimeAna &&) = delete;
  EvTimeAna & operator = (EvTimeAna const &) = delete;
  EvTimeAna & operator = (EvTimeAna &&) = delete;

  void analyze(art::Event const & e) override;

private:

  // Declare member data here.
  art::InputTag fHeaderTag;
  art::InputTag fHitsTag;
};


novaddt::EvTimeAna::EvTimeAna(fhicl::ParameterSet const & p)
  :
  EDAnalyzer(p), 
  fHeaderTag   (p.get< std::string >("header_tag"  )),
  fHitsTag(p.get<std::string>("hits_tag"))
{}

void novaddt::EvTimeAna::analyze(art::Event const & e)
{
    const double msec=64000;
    auto header=e.getValidHandle<novaddt::EventHeader>(fHeaderTag);
    double hdr_time = header->timeStart/msec;

    auto Hits  =e.getValidHandle<novaddt::HitList>(fHitsTag);
    auto hits_size =  Hits->size();
    double hits_time_0 = hits_size?Hits->front().TDC().val/msec-hdr_time:0;
    double hits_time_1 = hits_size?Hits->back().TDC().val/msec-hdr_time:0;
    std::cout.setf(std::ios::fixed);
    std::cout.precision(2);

    std::cout
        <<header->eventNumber<<"\t "
        <<header->missingData<<"\t "
        <<header->datablockCount<<"\t "
        <<header->timeStart<<"\t "
        <<hdr_time<<"\t "<<hits_size<<"\t "
        <<hits_time_0<<"\t "
        <<hits_time_1<<std::endl;

  // Implementation of required member function here.
}

DEFINE_ART_MODULE(novaddt::EvTimeAna)
